package org.jboss.crypto.digest;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.ByteArrayOutputStream;
import java.security.MessageDigest;
import java.security.MessageDigestSpi;
import java.security.NoSuchAlgorithmException;
import java.security.ProviderException;

public class SHAReverseInterleave extends MessageDigestSpi {
  private static final int SHA_HASH_LEN = 20;
  
  private ByteArrayOutputStream evenBytes;
  
  private ByteArrayOutputStream oddBytes;
  
  private int count;
  
  private boolean skipLeadingZeros;
  
  private MessageDigest sha;
  
  public SHAReverseInterleave() {
    try {
      this.sha = MessageDigest.getInstance("SHA");
    } catch (NoSuchAlgorithmException e) {
      throw new ProviderException("Failed to obtain SHA MessageDigest");
    } 
    this.evenBytes = new ByteArrayOutputStream();
    this.oddBytes = new ByteArrayOutputStream();
    engineReset();
  }
  
  protected int engineGetDigestLength() {
    return 40;
  }
  
  protected byte[] engineDigest() {
    byte[] E = this.evenBytes.toByteArray();
    int length = E.length;
    if (this.count % 2 == 1)
      length--; 
    byte[] tmp = new byte[length];
    for (int i = 0; i < length; i++) {
      tmp[i] = E[E.length - i - 1];
      System.out.println("E[" + i + "] = " + tmp[i]);
    } 
    E = tmp;
    byte[] G = this.sha.digest(E);
    byte[] F = this.oddBytes.toByteArray();
    tmp = new byte[F.length];
    for (int j = 0; j < F.length; j++) {
      tmp[j] = F[F.length - j - 1];
      System.out.println("F[" + j + "] = " + tmp[j]);
    } 
    F = tmp;
    this.sha.reset();
    byte[] H = this.sha.digest(F);
    length = G.length + H.length;
    byte[] digest = new byte[length];
    int k;
    for (k = 0; k < G.length; k++)
      digest[2 * k] = G[k]; 
    for (k = 0; k < H.length; k++)
      digest[2 * k + 1] = H[k]; 
    engineReset();
    return digest;
  }
  
  protected void engineReset() {
    this.skipLeadingZeros = true;
    this.count = 0;
    this.evenBytes.reset();
    this.oddBytes.reset();
    this.sha.reset();
  }
  
  protected void engineUpdate(byte input) {
    if (this.skipLeadingZeros == true && input == 0)
      return; 
    this.skipLeadingZeros = false;
    if (this.count % 2 == 0) {
      this.evenBytes.write(input);
    } else {
      this.oddBytes.write(input);
    } 
    this.count++;
  }
  
  protected void engineUpdate(byte[] input, int offset, int len) {
    for (int i = offset; i < offset + len; i++)
      engineUpdate(input[i]); 
  }
}
